"""
Module fermi_proj_routines


Defined at fermi_proj.fpp lines 29-195

"""
from __future__ import print_function, absolute_import, division
import _qepy
import f90wrap.runtime
import logging

_arrays = {}
_objs = {}

def read_projwfc():
    """
    lbinary = read_projwfc()
    
    
    Defined at fermi_proj.fpp lines 37-99
    
    
    Returns
    -------
    lbinary : bool
    
    -----------------------------------------------------------------------
     ... Read projwfc.x input file and use prefix, outdir, lbinary_data only.
    """
    lbinary = _qepy.f90wrap_read_projwfc()
    return lbinary

def read_atomic_proj(lbinary_data, wt, ns, nk):
    """
    read_atomic_proj(lbinary_data, wt, ns, nk)
    
    
    Defined at fermi_proj.fpp lines 103-193
    
    Parameters
    ----------
    lbinary_data : bool
    wt : float array
    ns : int
    nk : int
    
    -----------------------------------------------------------------------
     Read atomic_proj.* generated by projwfc.x
    """
    _qepy.f90wrap_read_atomic_proj(lbinary_data=lbinary_data, wt=wt, ns=ns, nk=nk)


_array_initialisers = []
_dt_array_initialisers = []

try:
    for func in _array_initialisers:
        func()
except ValueError:
    logging.debug('unallocated array(s) detected on import of module \
        "fermi_proj_routines".')

for func in _dt_array_initialisers:
    func()
