"""
Module fs


Defined at fermisurface.fpp lines 24-355

"""
from __future__ import print_function, absolute_import, division
import _qepy
import f90wrap.runtime
import logging

_arrays = {}
_objs = {}

def read_input_fs():
    """
    read_input_fs()
    
    
    Defined at fermisurface.fpp lines 52-98
    
    
    --------------------------------------------------------------------
    """
    _qepy.f90wrap_read_input_fs()

def fill_fs_grid():
    """
    fill_fs_grid()
    
    
    Defined at fermisurface.fpp lines 102-200
    
    
    -----------------------------------------------------------------------
    """
    _qepy.f90wrap_fill_fs_grid()

def write_xcrysden_fs():
    """
    write_xcrysden_fs()
    
    
    Defined at fermisurface.fpp lines 204-311
    
    
    -----------------------------------------------------------------------
    """
    _qepy.f90wrap_write_xcrysden_fs()


_array_initialisers = []
_dt_array_initialisers = []

try:
    for func in _array_initialisers:
        func()
except ValueError:
    logging.debug('unallocated array(s) detected on import of module "fs".')

for func in _dt_array_initialisers:
    func()
